#ifndef _LBBCBILLBOARDCLOUDTEXTUREVIEWMODE_H
#define _LBBCBILLBOARDCLOUDTEXTUREVIEWMODE_H

#include <LBBCPrerequisites.h>
#include <LBBCManager.h>
#include <IMG.h>
#include <OBAOgreFrameListenerMode.h>

namespace LBBC {

class _BBCExport ClusterTextureListener : public Ogre::RenderTargetListener
{
protected:
	IMG::TextureAtlasPtr mTextureAtlas;

	IMG::TexturePtr mTexture;

	unsigned int mNumTextures;

	unsigned int mCurrentTexture;

	unsigned int mSubEntityVisible;

	Ogre::Entity *mEntity;

public:
	
	void setEntity(Ogre::Entity *entity)
	{
		mEntity = entity;
	}

	void setSubEntityVisible(unsigned int iSubEntity)
	{
		mSubEntityVisible = iSubEntity;
	}

	void setTexture(IMG::TexturePtr texture)
	{
		mTexture = texture;
	}

	void setTextureAtlas(IMG::TextureAtlasPtr textureAtlas)
	{
		mTextureAtlas = textureAtlas;
	}

	void preRenderTargetUpdate(const Ogre::RenderTargetEvent& evt)
    {
		if (mCurrentTexture < mNumTextures)
		{
			//calculateProjectionMatrix(unsigned int iSubEntity, Ogre::Camera *cam);
			//initializeShaderParameters(unsigned int iSubEntity);
			mTexture->getRectangle2D()->setVisible(false);
			mTextureAtlas->getRectangle2D()->setVisible(false);
		}
    }

	void postRenderTargetUpdate(const Ogre::RenderTargetEvent& evt)
    {   

    }

	void setNumTextures(unsigned int numTextures)
	{
		mNumTextures = numTextures;
		mCurrentTexture = 0;
	}


};

class _BBCExport TextureAtlasListener : public Ogre::RenderTargetListener
{
public:
	void preRenderTargetUpdate(const Ogre::RenderTargetEvent& evt)
    {
		//configureTexture( unsigned int iSubEntity );
    }

	void postRenderTargetUpdate(const Ogre::RenderTargetEvent& evt)
    {
		
    }
};

class _BBCExport BillboardCloudTextureViewMode : public OBA::OgreFrameListenerMode 
{
	protected:
		unsigned int mFrame;

		Ogre::SceneNode *mClusterizedEntitiesMergedSceneNode;
		
		Ogre::Entity *mClusterizedEntities;

		ClusterTextureListener mClusterTextureListener;

		TextureAtlasListener mTextureAtlasListener;

		IMG::TexturePtr mClusterTexture;

		IMG::TextureAtlasPtr mTextureAtlas;

		unsigned int mNumTextures;

		unsigned int mCurrentTexture;

		unsigned int mTextureAtlasSize;

		unsigned int mTextureSize;

		unsigned int mBitRange;

		Ogre::PixelFormat mSrcPixelFormat;

		Ogre::PixelFormat mDestPixelFormat;

		Ogre::String mTextureAtlasName;

		Ogre::String mTextureAtlasFolder;

		Ogre::String mEntityName;

	public:

		BillboardCloudTextureViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false);

		virtual ~BillboardCloudTextureViewMode();		

		virtual bool frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader);

		virtual void createScene();

		virtual void destroyScene();
		
		void setTextureAtlasSize(unsigned int size);

		void setTextureSize(unsigned int size);

		void setEntityName(Ogre::String entityName);

		void setTextureAtlasName(Ogre::String textureAtlasName);

		void setTextureAtlasFolder(Ogre::String textureAtlasFolder);

		void setTextureAtlasBitRange(unsigned int bitRange);
};

}
#endif
